function [nGestures, nTotal, p] = calc_mle(prior, transmat, obsmat, filenames, filelength, nStart, nEnd, data_set)
%N: no. of training cases 
%beginning index of training examples 

Tt=6; %length of a case 

nTotal = 0; 
for n=nStart:nEnd
     if (eq(data_set(1,n),0))
        nTotal = nTotal + filelength(n);   
    end
end

loglik = 1:nTotal; 
nGestures = 0; 

FID = fopen('G:\assets\DBNparams.csv','a'); 
ntsofar =0; 

for n=nStart:nEnd
    if (eq(data_set(1,n),0))
        s = filenames(n,:);
        test = load (s);
        nt = filelength(n);
        testdata	= test(1:nt,1:Tt);
        for a=1:nt
            loglik(a+ntsofar) = dhmm_logprob(testdata(a,:), prior, transmat, obsmat);     
            if (loglik(a+ntsofar)> -7)
                nGestures = nGestures+1;       
            end 
        fprintf(FID, '%6.2f\n', loglik(a+ntsofar));
        end
    %n
    ntsofar=ntsofar + nt; 
    end
end 
%[p, pci] = mle('Normal', loglik)
p= nGestures / nTotal;

%fprintf(FID, '%6.2f\n', p);

fprintf(FID,'\n');
fclose(FID);